


<h1><a name="app_engine" id="app_engine">App Engine</a></h1>
<div class="level1">

<p>

<a href="http://code.google.com/appengine/" class="urlextern" title="http://code.google.com/appengine/"  rel="nofollow">Google App Engine</a>: <a href="http://en.wikipedia.org/wiki/Google_App_Engine" class="interwiki iw_wp" title="http://en.wikipedia.org/wiki/Google_App_Engine">Google App Engine</a> <br/>

</p>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "App Engine" [1-130] -->
<h2><a name="example" id="example">Example</a></h2>
<div class="level2">
<pre class="code python"><span class="kw1">from</span> google.<span class="me1">appengine</span>.<span class="me1">ext</span> <span class="kw1">import</span> webapp
<span class="kw1">from</span> google.<span class="me1">appengine</span>.<span class="me1">ext</span>.<span class="me1">webapp</span>.<span class="me1">util</span> <span class="kw1">import</span> run_wsgi_app
<span class="kw1">from</span> google.<span class="me1">appengine</span>.<span class="me1">ext</span> <span class="kw1">import</span> db
<span class="kw1">import</span> <span class="kw3">urllib</span>
<span class="kw1">from</span> <span class="kw3">HTMLParser</span> <span class="kw1">import</span> <span class="kw3">HTMLParser</span>
<span class="kw1">import</span> <span class="kw3">re</span>
&nbsp;
<span class="kw1">class</span> MyHTMLParser<span class="br0">&#40;</span><span class="kw3">HTMLParser</span><span class="br0">&#41;</span>:
	<span class="kw1">def</span> <span class="kw4">__init__</span><span class="br0">&#40;</span><span class="kw2">self</span><span class="br0">&#41;</span>:
		<span class="kw3">HTMLParser</span>.<span class="kw4">__init__</span><span class="br0">&#40;</span><span class="kw2">self</span><span class="br0">&#41;</span>
		<span class="kw2">self</span>.<span class="me1">s</span> = <span class="st0">''</span>
&nbsp;
	<span class="kw1">def</span> handle_starttag<span class="br0">&#40;</span><span class="kw2">self</span>, tag, attrs<span class="br0">&#41;</span>:
		<span class="kw1">if</span> tag == <span class="st0">'embed'</span>:
			<span class="kw1">for</span> attr <span class="kw1">in</span> attrs:
				<span class="kw1">if</span> attr<span class="br0">&#91;</span><span class="nu0">0</span><span class="br0">&#93;</span> == <span class="st0">'flashvars'</span>:
					<span class="kw2">self</span>.<span class="me1">s</span> = attr<span class="br0">&#91;</span>1<span class="br0">&#93;</span>
&nbsp;
	<span class="kw1">def</span> feed<span class="br0">&#40;</span><span class="kw2">self</span>, data<span class="br0">&#41;</span>:
		<span class="kw3">HTMLParser</span>.<span class="me1">feed</span><span class="br0">&#40;</span><span class="kw2">self</span>, data<span class="br0">&#41;</span>
		<span class="kw1">return</span> <span class="kw2">self</span>
&nbsp;
	<span class="kw1">def</span> get_s<span class="br0">&#40;</span><span class="kw2">self</span><span class="br0">&#41;</span>:
		<span class="kw1">return</span> <span class="kw2">self</span>.<span class="me1">s</span>
&nbsp;
<span class="kw1">class</span> Level<span class="br0">&#40;</span>db.<span class="me1">Model</span><span class="br0">&#41;</span>:
	content = db.<span class="me1">TextProperty</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
&nbsp;
<span class="kw1">class</span> Current<span class="br0">&#40;</span>db.<span class="me1">Model</span><span class="br0">&#41;</span>:
	x = db.<span class="me1">IntegerProperty</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
	y = db.<span class="me1">IntegerProperty</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
	d = db.<span class="me1">IntegerProperty</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
	n = db.<span class="me1">IntegerProperty</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
	m = db.<span class="me1">IntegerProperty</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
	l = db.<span class="me1">IntegerProperty</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
&nbsp;
<span class="kw1">class</span> Wrong<span class="br0">&#40;</span>db.<span class="me1">Model</span><span class="br0">&#41;</span>:
	x = db.<span class="me1">IntegerProperty</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
	y = db.<span class="me1">IntegerProperty</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
	d = db.<span class="me1">IntegerProperty</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
	l = db.<span class="me1">IntegerProperty</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
&nbsp;
<span class="kw1">class</span> CrossPage<span class="br0">&#40;</span>webapp.<span class="me1">RequestHandler</span><span class="br0">&#41;</span>:
	<span class="kw1">def</span> get<span class="br0">&#40;</span><span class="kw2">self</span><span class="br0">&#41;</span>:
		url = <span class="st0">'http://www.hacker.org/cross/index.php?name=kauesilv&amp;password=a1b2c3d4'</span>
		regex = r<span class="st0">'boardinit = &quot;([^&quot;]*)&quot;'</span>
		debug = <span class="kw2">self</span>.<span class="me1">request</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">'debug'</span><span class="br0">&#41;</span>
		s = <span class="kw2">self</span>.<span class="me1">request</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">'s'</span><span class="br0">&#41;</span>
		path = <span class="kw2">self</span>.<span class="me1">request</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">'path'</span><span class="br0">&#41;</span>
		<span class="kw2">self</span>.<span class="me1">response</span>.<span class="me1">headers</span><span class="br0">&#91;</span><span class="st0">'Content-Type'</span><span class="br0">&#93;</span> = <span class="st0">'text/plain'</span>
		<span class="kw1">if</span> s == <span class="st0">'1'</span>:
			<span class="kw3">urllib</span>.<span class="me1">urlopen</span><span class="br0">&#40;</span>url + <span class="st0">'&amp;sol='</span> + path<span class="br0">&#41;</span>.<span class="me1">read</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
		s = <span class="kw3">urllib</span>.<span class="me1">urlopen</span><span class="br0">&#40;</span>url<span class="br0">&#41;</span>.<span class="me1">read</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
		<span class="co1">#self.response.out.write(s + '\n')</span>
		board = <span class="kw3">re</span>.<span class="kw2">compile</span><span class="br0">&#40;</span>regex<span class="br0">&#41;</span>.<span class="me1">search</span><span class="br0">&#40;</span>s<span class="br0">&#41;</span>.<span class="me1">groups</span><span class="br0">&#40;</span><span class="br0">&#41;</span><span class="br0">&#91;</span><span class="nu0">0</span><span class="br0">&#93;</span>.<span class="me1">split</span><span class="br0">&#40;</span><span class="st0">','</span><span class="br0">&#41;</span>
		<span class="kw2">self</span>.<span class="me1">response</span>.<span class="me1">out</span>.<span class="me1">write</span><span class="br0">&#40;</span><span class="kw2">str</span><span class="br0">&#40;</span><span class="kw2">len</span><span class="br0">&#40;</span>board<span class="br0">&#41;</span><span class="br0">&#41;</span> + <span class="st0">'<span class="es0">\n</span>'</span> + <span class="kw2">str</span><span class="br0">&#40;</span><span class="kw2">len</span><span class="br0">&#40;</span>board<span class="br0">&#91;</span><span class="nu0">0</span><span class="br0">&#93;</span><span class="br0">&#41;</span><span class="br0">&#41;</span> + <span class="st0">'<span class="es0">\n</span>'</span><span class="br0">&#41;</span>
		<span class="kw1">for</span> line <span class="kw1">in</span> board:
			<span class="kw2">self</span>.<span class="me1">response</span>.<span class="me1">out</span>.<span class="me1">write</span><span class="br0">&#40;</span><span class="kw2">str</span><span class="br0">&#40;</span>line<span class="br0">&#41;</span> + <span class="st0">'<span class="es0">\n</span>'</span><span class="br0">&#41;</span>
&nbsp;
<span class="kw1">class</span> MainPage<span class="br0">&#40;</span>webapp.<span class="me1">RequestHandler</span><span class="br0">&#41;</span>:
	<span class="kw1">def</span> get<span class="br0">&#40;</span><span class="kw2">self</span><span class="br0">&#41;</span>:
		delete = <span class="kw2">self</span>.<span class="me1">request</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">'delete'</span><span class="br0">&#41;</span>
		<span class="kw1">if</span> delete == <span class="st0">'1'</span>:
			db.<span class="me1">delete</span><span class="br0">&#40;</span>Wrong.<span class="kw2">all</span><span class="br0">&#40;</span><span class="br0">&#41;</span>.<span class="me1">fetch</span><span class="br0">&#40;</span>100<span class="br0">&#41;</span><span class="br0">&#41;</span>
			<span class="kw1">if</span> Wrong.<span class="kw2">all</span><span class="br0">&#40;</span><span class="br0">&#41;</span>.<span class="me1">count</span><span class="br0">&#40;</span>1<span class="br0">&#41;</span> == 1:
				<span class="kw1">return</span>
&nbsp;
		url = <span class="st0">'http://www.hacker.org/coil/index.php?name=kauesilv&amp;password=a1b2c3d4'</span>
		regex = r<span class="st0">'x=(<span class="es0">\d</span>*)&amp;y=(<span class="es0">\d</span>*)&amp;board=(.*)'</span>
		regexLevel = r<span class="st0">'Level: (<span class="es0">\d</span>*)'</span>
		<span class="kw2">self</span>.<span class="me1">response</span>.<span class="me1">headers</span><span class="br0">&#91;</span><span class="st0">'Content-Type'</span><span class="br0">&#93;</span> = <span class="st0">'text/plain'</span>
		debug = <span class="kw2">self</span>.<span class="me1">request</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">'debug'</span><span class="br0">&#41;</span>
		s = <span class="kw2">self</span>.<span class="me1">request</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">'s'</span><span class="br0">&#41;</span>
		r = <span class="kw2">self</span>.<span class="me1">request</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">'r'</span><span class="br0">&#41;</span>
		x = <span class="kw2">self</span>.<span class="me1">request</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">'x'</span><span class="br0">&#41;</span>
		y = <span class="kw2">self</span>.<span class="me1">request</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">'y'</span><span class="br0">&#41;</span>
		d = <span class="kw2">self</span>.<span class="me1">request</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">'d'</span><span class="br0">&#41;</span>
		w = <span class="kw2">self</span>.<span class="me1">request</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">'w'</span><span class="br0">&#41;</span>
		path = <span class="kw2">self</span>.<span class="me1">request</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">'path'</span><span class="br0">&#41;</span>
&nbsp;
		levels = Level.<span class="kw2">all</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
		currents = Current.<span class="kw2">all</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
&nbsp;
		<span class="kw1">if</span> s == <span class="st0">'1'</span>:
			<span class="kw3">urllib</span>.<span class="me1">urlopen</span><span class="br0">&#40;</span>url + <span class="st0">'&amp;x='</span> + x + <span class="st0">'&amp;y='</span> + y + <span class="st0">'&amp;path='</span> + path<span class="br0">&#41;</span>.<span class="me1">read</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
&nbsp;
		<span class="kw1">if</span> w == <span class="st0">'1'</span>:
			wrong = Wrong<span class="br0">&#40;</span><span class="br0">&#41;</span>
			wrong.<span class="me1">x</span> = <span class="kw2">int</span><span class="br0">&#40;</span>x<span class="br0">&#41;</span>
			wrong.<span class="me1">y</span> = <span class="kw2">int</span><span class="br0">&#40;</span>y<span class="br0">&#41;</span>
			wrong.<span class="me1">d</span> = <span class="kw2">int</span><span class="br0">&#40;</span>d<span class="br0">&#41;</span>
			wrong.<span class="me1">l</span> = currents.<span class="me1">fetch</span><span class="br0">&#40;</span>1<span class="br0">&#41;</span><span class="br0">&#91;</span>0<span class="br0">&#93;</span>.<span class="me1">l</span>
			wrong.<span class="me1">put</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
&nbsp;
		<span class="kw1">if</span> s == <span class="st0">'1'</span> <span class="kw1">or</span> r == <span class="st0">'1'</span>:
			s = <span class="kw3">urllib</span>.<span class="me1">urlopen</span><span class="br0">&#40;</span>url<span class="br0">&#41;</span>.<span class="me1">read</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
			x, y, board = <span class="kw3">re</span>.<span class="kw2">compile</span><span class="br0">&#40;</span>regex<span class="br0">&#41;</span>.<span class="me1">search</span><span class="br0">&#40;</span>MyHTMLParser<span class="br0">&#40;</span><span class="br0">&#41;</span>.<span class="me1">feed</span><span class="br0">&#40;</span>s<span class="br0">&#41;</span>.<span class="me1">get_s</span><span class="br0">&#40;</span><span class="br0">&#41;</span><span class="br0">&#41;</span>.<span class="me1">groups</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
			lvl, = <span class="kw3">re</span>.<span class="kw2">compile</span><span class="br0">&#40;</span>regexLevel<span class="br0">&#41;</span>.<span class="me1">search</span><span class="br0">&#40;</span>s<span class="br0">&#41;</span>.<span class="me1">groups</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
			db.<span class="me1">delete</span><span class="br0">&#40;</span>Level.<span class="kw2">all</span><span class="br0">&#40;</span><span class="br0">&#41;</span>.<span class="me1">fetch</span><span class="br0">&#40;</span>1000000<span class="br0">&#41;</span><span class="br0">&#41;</span>
			db.<span class="me1">delete</span><span class="br0">&#40;</span>Current.<span class="kw2">all</span><span class="br0">&#40;</span><span class="br0">&#41;</span>.<span class="me1">fetch</span><span class="br0">&#40;</span><span class="nu0">1000000</span><span class="br0">&#41;</span><span class="br0">&#41;</span>
&nbsp;
			level = Level<span class="br0">&#40;</span><span class="br0">&#41;</span>
			level.<span class="me1">content</span> = x + <span class="st0">'<span class="es0">\n</span>'</span> + y + <span class="st0">'<span class="es0">\n</span>'</span> + board + <span class="st0">'<span class="es0">\n</span>'</span>
			level.<span class="me1">put</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
&nbsp;
			current = Current<span class="br0">&#40;</span><span class="br0">&#41;</span>
			current.<span class="me1">x</span> = current.<span class="me1">y</span> = current.<span class="me1">d</span> = 0
			current.<span class="me1">n</span> = <span class="kw2">int</span><span class="br0">&#40;</span>x<span class="br0">&#41;</span>
			current.<span class="me1">m</span> = <span class="kw2">int</span><span class="br0">&#40;</span>y<span class="br0">&#41;</span>
			current.<span class="me1">l</span> = <span class="kw2">int</span><span class="br0">&#40;</span>lvl<span class="br0">&#41;</span>
			current.<span class="me1">put</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
&nbsp;
		cur = currents.<span class="me1">fetch</span><span class="br0">&#40;</span>1<span class="br0">&#41;</span><span class="br0">&#91;</span>0<span class="br0">&#93;</span>
		<span class="kw1">while</span><span class="br0">&#40;</span><span class="kw2">True</span><span class="br0">&#41;</span>:
			cur.<span class="me1">d</span> = cur.<span class="me1">d</span> + 1
			<span class="kw1">if</span><span class="br0">&#40;</span>cur.<span class="me1">d</span> == 4<span class="br0">&#41;</span>:
				cur.<span class="me1">d</span> = 0
				cur.<span class="me1">y</span> = cur.<span class="me1">y</span> + 1
				<span class="kw1">if</span><span class="br0">&#40;</span>cur.<span class="me1">y</span> == cur.<span class="me1">m</span><span class="br0">&#41;</span>:
					cur.<span class="me1">y</span> = 0
					cur.<span class="me1">x</span> = cur.<span class="me1">x</span> + 1
					<span class="kw1">if</span><span class="br0">&#40;</span>cur.<span class="me1">x</span> == cur.<span class="me1">n</span><span class="br0">&#41;</span>:
						cur.<span class="me1">x</span> = <span class="nu0">0</span>
			cur.<span class="me1">put</span><span class="br0">&#40;</span><span class="br0">&#41;</span>
			wrong = Wrong<span class="br0">&#40;</span><span class="br0">&#41;</span>.<span class="me1">gql</span><span class="br0">&#40;</span><span class="st0">&quot;WHERE x = :1 AND y = :2 AND d = :3 AND l = :4&quot;</span>, cur.<span class="me1">x</span>, cur.<span class="me1">y</span>, cur.<span class="me1">d</span>, cur.<span class="me1">l</span><span class="br0">&#41;</span>
			<span class="kw1">if</span><span class="br0">&#40;</span>wrong.<span class="me1">count</span><span class="br0">&#40;</span>1<span class="br0">&#41;</span> == 0<span class="br0">&#41;</span>:
				<span class="kw1">break</span>
&nbsp;
		<span class="kw2">self</span>.<span class="me1">response</span>.<span class="me1">out</span>.<span class="me1">write</span><span class="br0">&#40;</span><span class="kw2">str</span><span class="br0">&#40;</span>cur.<span class="me1">x</span><span class="br0">&#41;</span> + <span class="st0">'<span class="es0">\n</span>'</span> + <span class="kw2">str</span><span class="br0">&#40;</span>cur.<span class="me1">y</span><span class="br0">&#41;</span> + <span class="st0">'<span class="es0">\n</span>'</span> + <span class="kw2">str</span><span class="br0">&#40;</span>cur.<span class="me1">d</span><span class="br0">&#41;</span> + <span class="st0">'<span class="es0">\n</span>'</span> + <span class="kw2">str</span><span class="br0">&#40;</span>cur.<span class="me1">l</span><span class="br0">&#41;</span> + <span class="st0">'<span class="es0">\n</span>'</span><span class="br0">&#41;</span>
		<span class="kw2">self</span>.<span class="me1">response</span>.<span class="me1">out</span>.<span class="me1">write</span><span class="br0">&#40;</span>levels.<span class="me1">fetch</span><span class="br0">&#40;</span>1<span class="br0">&#41;</span><span class="br0">&#91;</span>0<span class="br0">&#93;</span>.<span class="me1">content</span><span class="br0">&#41;</span>
&nbsp;
		<span class="kw1">if</span> debug == <span class="st0">'1'</span>:
			<span class="kw2">self</span>.<span class="me1">response</span>.<span class="me1">out</span>.<span class="me1">write</span><span class="br0">&#40;</span><span class="st0">'<span class="es0">\n</span><span class="es0">\n</span>----DEBUG----<span class="es0">\n</span><span class="es0">\n</span>wrongs<span class="es0">\n</span>'</span><span class="br0">&#41;</span>
			wrongs = Wrong.<span class="me1">gql</span><span class="br0">&#40;</span><span class="st0">&quot;WHERE l = :1&quot;</span>, cur.<span class="me1">l</span><span class="br0">&#41;</span>
			<span class="kw1">for</span> wrong <span class="kw1">in</span> wrongs:
				<span class="kw2">self</span>.<span class="me1">response</span>.<span class="me1">out</span>.<span class="me1">write</span><span class="br0">&#40;</span><span class="kw2">str</span><span class="br0">&#40;</span>wrong.<span class="me1">x</span><span class="br0">&#41;</span> + <span class="st0">' '</span> + <span class="kw2">str</span><span class="br0">&#40;</span>wrong.<span class="me1">y</span><span class="br0">&#41;</span> + <span class="st0">' '</span> + <span class="kw2">str</span><span class="br0">&#40;</span>wrong.<span class="me1">d</span><span class="br0">&#41;</span> + <span class="st0">' '</span> + <span class="kw2">str</span><span class="br0">&#40;</span>wrong.<span class="me1">l</span><span class="br0">&#41;</span> + <span class="st0">'<span class="es0">\n</span>'</span><span class="br0">&#41;</span>
&nbsp;
			<span class="kw2">self</span>.<span class="me1">response</span>.<span class="me1">out</span>.<span class="me1">write</span><span class="br0">&#40;</span><span class="st0">'<span class="es0">\n</span>currents<span class="es0">\n</span>'</span><span class="br0">&#41;</span>
			<span class="kw1">for</span> current <span class="kw1">in</span> currents:
				<span class="kw2">self</span>.<span class="me1">response</span>.<span class="me1">out</span>.<span class="me1">write</span><span class="br0">&#40;</span><span class="kw2">str</span><span class="br0">&#40;</span>current.<span class="me1">x</span><span class="br0">&#41;</span> + <span class="st0">' '</span> + <span class="kw2">str</span><span class="br0">&#40;</span>current.<span class="me1">y</span><span class="br0">&#41;</span> + <span class="st0">' '</span> + <span class="kw2">str</span><span class="br0">&#40;</span>current.<span class="me1">d</span><span class="br0">&#41;</span> + <span class="st0">' '</span> + <span class="kw2">str</span><span class="br0">&#40;</span>current.<span class="me1">l</span><span class="br0">&#41;</span> + <span class="st0">'<span class="es0">\n</span>'</span><span class="br0">&#41;</span>
&nbsp;
application = webapp.<span class="me1">WSGIApplication</span><span class="br0">&#40;</span><span class="br0">&#91;</span><span class="br0">&#40;</span><span class="st0">'/'</span>, MainPage<span class="br0">&#41;</span>, <span class="br0">&#40;</span><span class="st0">'/cross'</span>, CrossPage<span class="br0">&#41;</span><span class="br0">&#93;</span>, debug=<span class="kw2">True</span><span class="br0">&#41;</span>
&nbsp;
<span class="kw1">def</span> main<span class="br0">&#40;</span><span class="br0">&#41;</span>:
	run_wsgi_app<span class="br0">&#40;</span>application<span class="br0">&#41;</span>
&nbsp;
<span class="kw1">if</span> __name__ == <span class="st0">&quot;__main__&quot;</span>:
	main<span class="br0">&#40;</span><span class="br0">&#41;</span></pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Example" [131-] -->